/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables.records;


import de.ship.db.enums.EnumDevicestate;
import de.ship.db.tables.TCoreDevice;

import java.time.LocalDateTime;

import org.jooq.Record1;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreDeviceRecord extends UpdatableRecordImpl<TCoreDeviceRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>common_dd.t_core_device.lastchange</code>.
     */
    public void setLastchange(LocalDateTime value) {
        set(0, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.lastchange</code>.
     */
    public LocalDateTime getLastchange() {
        return (LocalDateTime) get(0);
    }

    /**
     * Setter for <code>common_dd.t_core_device.pk</code>.
     */
    public void setPk(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.pk</code>.
     */
    public Integer getPk() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>common_dd.t_core_device.device_id</code>. unique device
     * id defined by SHIP-IT
     */
    public void setDeviceId(String value) {
        set(2, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.device_id</code>. unique device
     * id defined by SHIP-IT
     */
    public String getDeviceId() {
        return (String) get(2);
    }

    /**
     * Setter for <code>common_dd.t_core_device.name</code>. display name of
     * device for end user
     */
    public void setName(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.name</code>. display name of
     * device for end user
     */
    public String getName() {
        return (String) get(3);
    }

    /**
     * Setter for <code>common_dd.t_core_device.type</code>. device name
     */
    public void setType(String value) {
        set(4, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.type</code>. device name
     */
    public String getType() {
        return (String) get(4);
    }

    /**
     * Setter for <code>common_dd.t_core_device.manufactor</code>. manufactor
     * name
     */
    public void setManufactor(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.manufactor</code>. manufactor
     * name
     */
    public String getManufactor() {
        return (String) get(5);
    }

    /**
     * Setter for <code>common_dd.t_core_device.serialnr</code>. serial number
     */
    public void setSerialnr(String value) {
        set(6, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.serialnr</code>. serial number
     */
    public String getSerialnr() {
        return (String) get(6);
    }

    /**
     * Setter for <code>common_dd.t_core_device.invnr</code>. ship internal
     * inventory number
     */
    public void setInvnr(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.invnr</code>. ship internal
     * inventory number
     */
    public String getInvnr() {
        return (String) get(7);
    }

    /**
     * Setter for <code>common_dd.t_core_device.buildyear</code>. construction
     * year
     */
    public void setBuildyear(String value) {
        set(8, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.buildyear</code>. construction
     * year
     */
    public String getBuildyear() {
        return (String) get(8);
    }

    /**
     * Setter for <code>common_dd.t_core_device.state</code>. state of device
     */
    public void setState(EnumDevicestate value) {
        set(9, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.state</code>. state of device
     */
    public EnumDevicestate getState() {
        return (EnumDevicestate) get(9);
    }

    /**
     * Setter for <code>common_dd.t_core_device.contact</code>. contact, if not
     * medical technic
     */
    public void setContact(String value) {
        set(10, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.contact</code>. contact, if not
     * medical technic
     */
    public String getContact() {
        return (String) get(10);
    }

    /**
     * Setter for <code>common_dd.t_core_device.location</code>. location of
     * device
     */
    public void setLocation(String value) {
        set(11, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.location</code>. location of
     * device
     */
    public String getLocation() {
        return (String) get(11);
    }

    /**
     * Setter for <code>common_dd.t_core_device.obs_name</code>. observation
     * name
     */
    public void setObsName(String value) {
        set(12, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.obs_name</code>. observation
     * name
     */
    public String getObsName() {
        return (String) get(12);
    }

    /**
     * Setter for <code>common_dd.t_core_device.fk_element</code>. study the
     * device was bought for
     */
    public void setFkElement(Integer value) {
        set(13, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.fk_element</code>. study the
     * device was bought for
     */
    public Integer getFkElement() {
        return (Integer) get(13);
    }

    /**
     * Setter for <code>common_dd.t_core_device.resp_obs_mail</code>. mail of
     * responsible observation person
     */
    public void setRespObsMail(String value) {
        set(14, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.resp_obs_mail</code>. mail of
     * responsible observation person
     */
    public String getRespObsMail() {
        return (String) get(14);
    }

    /**
     * Setter for <code>common_dd.t_core_device.resp_qa</code>. mail of
     * responsible quality person
     */
    public void setRespQa(String value) {
        set(15, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.resp_qa</code>. mail of
     * responsible quality person
     */
    public String getRespQa() {
        return (String) get(15);
    }

    /**
     * Setter for <code>common_dd.t_core_device.color</code>. color of device
     * for analysis views
     */
    public void setColor(String value) {
        set(16, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.color</code>. color of device
     * for analysis views
     */
    public String getColor() {
        return (String) get(16);
    }

    /**
     * Setter for <code>common_dd.t_core_device.note</code>. notes for that
     * device
     */
    public void setNote(String value) {
        set(17, value);
    }

    /**
     * Getter for <code>common_dd.t_core_device.note</code>. notes for that
     * device
     */
    public String getNote() {
        return (String) get(17);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TCoreDeviceRecord
     */
    public TCoreDeviceRecord() {
        super(TCoreDevice.T_CORE_DEVICE);
    }

    /**
     * Create a detached, initialised TCoreDeviceRecord
     */
    public TCoreDeviceRecord(LocalDateTime lastchange, Integer pk, String deviceId, String name, String type, String manufactor, String serialnr, String invnr, String buildyear, EnumDevicestate state, String contact, String location, String obsName, Integer fkElement, String respObsMail, String respQa, String color, String note) {
        super(TCoreDevice.T_CORE_DEVICE);

        setLastchange(lastchange);
        setPk(pk);
        setDeviceId(deviceId);
        setName(name);
        setType(type);
        setManufactor(manufactor);
        setSerialnr(serialnr);
        setInvnr(invnr);
        setBuildyear(buildyear);
        setState(state);
        setContact(contact);
        setLocation(location);
        setObsName(obsName);
        setFkElement(fkElement);
        setRespObsMail(respObsMail);
        setRespQa(respQa);
        setColor(color);
        setNote(note);
        resetChangedOnNotNull();
    }
}
